<?php

class DpDiviFilterGrid extends ET_Builder_Module {

	public $slug = 'dpdfg_filtergrid';
	public $vb_support = 'on';
	protected $module_credits = array(
		'module_uri' => 'https://diviplugins.com/downloads/divi-filtergrid/',
		'author'     => 'DiviPlugins',
		'author_uri' => 'http://diviplugins.com',
	);

	public function init() {
		$this->name             = __( 'Divi FilterGrid', 'dpdfg-dp-divi-filtergrid' );
		$this->icon_path        = DPDFG_DIR . 'divi-filtergrid.svg';
		$this->main_css_element = '%%order_class%%';
		$this->help_videos      = array(
			array(
				'id'   => esc_html__( 'XlEr9Qn-H5Y', 'dpdfg-dp-divi-filtergrid' ),
				'name' => esc_html__( 'Divi FilterGrid', 'dpdfg-dp-divi-filtergrid' ),
			),
		);
		$this->fields_defaults  = array(
			'items_width_last_edited'     => array(
				'on|desktop',
				'add_default_setting',
			),
			'items_width_phone'           => array( '40%', 'add_default_setting' ),
			'items_width_tablet'          => array( '30%', 'add_default_setting' ),
			'grid_font_size_last_edited'  => array(
				'on|desktop',
				'add_default_setting',
			),
			'grid_font_size_phone'        => array( '10px', 'add_default_setting' ),
			'grid_font_size_tablet'       => array( '10px', 'add_default_setting' ),
			'thumb_min_width_last_edited' => array(
				'on|desktop',
				'add_default_setting',
			),
			'thumb_min_width_tablet'      => array( '300px', 'add_default_setting' ),
			'thumb_width_last_edited'     => array(
				'on|desktop',
				'add_default_setting',
			),
			'thumb_width_tablet'          => array( '33%', 'add_default_setting' ),
			'filters_width_last_edited'   => array(
				'on|desktop',
				'add_default_setting',
			),
			'filters_width_phone'         => array( '2', 'add_default_setting' ),
			'filters_width_tablet'        => array( '3', 'add_default_setting' ),
		);
	}

	public function get_settings_modal_toggles() {
		return array(
			'general'  => array(
				'toggles' => array(
					'query_options'      => __( 'Query Options', 'dpdfg-dp-divi-filtergrid' ),
					'elements_options'   => __( 'Posts Elements', 'dpdfg-dp-divi-filtergrid' ),
					'filter_options'     => __( 'Filters Options', 'dpdfg-dp-divi-filtergrid' ),
					'search_options'     => __( 'Search Options', 'dpdfg-dp-divi-filtergrid' ),
					'pagination_options' => __( 'Pagination Options', 'dpdfg-dp-divi-filtergrid' ),
					'cache_options'      => __( 'Cache Options', 'dpdfg-dp-divi-filtergrid' ),
				),
			),
			'advanced' => array(
				'toggles' => array(
					'layout_options' => __( 'Layout Options', 'dpdfg-dp-divi-filtergrid' ),
				),
			),
		);
	}

	public function get_advanced_fields_config() {
		return array(
			'fonts'      => array(
				'dpdfg_entry_title'       => array(
					'label'        => __( 'Post Title', 'dpdfg-dp-divi-filtergrid' ),
					'css'          => array(
						'main'      => "{$this->main_css_element} .entry-header .entry-title",
						'important' => 'all',
					),
					'line_height'  => array( 'default' => '1em' ),
					'font_size'    => array( 'default' => '18px' ),
					'header_level' => true,
				),
				'dpdfg_entry_meta'        => array(
					'label'       => __( 'Post Meta', 'dpdfg-dp-divi-filtergrid' ),
					'css'         => array(
						'main'        => "{$this->main_css_element} .entry-meta span, {$this->main_css_element} .entry-meta span a",
						'text_align'  => "{$this->main_css_element} .entry-meta",
						'line_height' => "{$this->main_css_element} .entry-meta",
						'important'   => 'all',
					),
					'line_height' => array( 'default' => '1.7em' ),
					'font_size'   => array( 'default' => '14px' ),
				),
				'dpdfg_entry_summary'     => array(
					'label'       => __( 'Post Excerpt', 'dpdfg-dp-divi-filtergrid' ),
					'css'         => array(
						'main'      => "{$this->main_css_element} .entry-summary",
						'important' => 'all',
					),
					'line_height' => array( 'default' => '1.7em' ),
					'font_size'   => array( 'default' => '14px' ),
				),
				'dpdfg_entry_custom'      => array(
					'label'       => __( 'Post Custom Content', 'dpdfg-dp-divi-filtergrid' ),
					'css'         => array(
						'main'      => "{$this->main_css_element} .dp-dfg-custom-content",
						'important' => 'all',
					),
					'line_height' => array( 'default' => '1.7em' ),
					'font_size'   => array( 'default' => '14px' ),
				),
				'dpdfg_search'            => array(
					'label'           => __( 'Search Input', 'dpdfg-dp-divi-filtergrid' ),
					'css'             => array(
						'main'      => "{$this->main_css_element} .dp-dfg-search-input",
						'important' => 'all',
					),
					'hide_text_align' => true,
					'line_height'     => array( 'default' => '1em' ),
					'font_size'       => array( 'default' => '14px' ),
				),
				'dpdfg_levels_labels'     => array(
					'label'       => __( 'Levels Label', 'dpdfg-dp-divi-filtergrid' ),
					'css'         => array(
						'main'      => "{$this->main_css_element} .dp-dfg-taxonomy-label",
						'important' => 'all',
					),
					'line_height' => array( 'default' => '1em' ),
					'font_size'   => array( 'default' => '20px' ),
				),
				'dpdfg_dropdown_labels'   => array(
					'label'           => __( 'Select Placeholder', 'dpdfg-dp-divi-filtergrid' ),
					'css'             => array(
						'main'      => "{$this->main_css_element} .dp-dfg-dropdown-label",
						'important' => 'all',
					),
					'hide_text_align' => true,
					'line_height'     => array( 'default' => '2em' ),
					'font_size'       => array( 'default' => '14px' ),
				),
				'dpdfg_dropdown_tags'     => array(
					'label'           => __( 'Select Placeholder Active Filter', 'dpdfg-dp-divi-filtergrid' ),
					'css'             => array(
						'main'      => "{$this->main_css_element} .dp-dfg-dropdown-tag",
						'important' => 'all',
					),
					'hide_text_align' => true,
					'line_height'     => array( 'default' => '1em' ),
					'font_size'       => array( 'default' => '14px' ),
				),
				'dpdfg_filters'           => array(
					'label'           => __( 'Button/Select Dropdown Filters', 'dpdfg-dp-divi-filtergrid' ),
					'css'             => array(
						'main'      => "{$this->main_css_element} .dp-dfg-filter .dp-dfg-filter-link",
						'important' => 'all',
					),
					'hide_text_align' => true,
					'line_height'     => array( 'default' => '1.9em' ),
					'font_size'       => array( 'default' => '14px' ),
				),
				'dpdfg_filters_active'    => array(
					'label'           => __( 'Button/Select Dropdown Active Filter', 'dpdfg-dp-divi-filtergrid' ),
					'css'             => array(
						'main'      => "{$this->main_css_element} .dp-dfg-filter .dp-dfg-filter-link.active",
						'important' => 'all',
					),
					'hide_text_align' => true,
					'line_height'     => array( 'default' => '1.9em' ),
					'font_size'       => array( 'default' => '14px' ),
				),
				'dpdfg_pagination'        => array(
					'label'           => __( 'Pagination', 'dpdfg-dp-divi-filtergrid' ),
					'css'             => array(
						'main'      => "{$this->main_css_element} .dp-dfg-pagination ul.pagination li a",
						'important' => 'all',
					),
					'hide_text_align' => true,
					'line_height'     => array( 'default' => '1.9em' ),
					'font_size'       => array( 'default' => '14px' ),
				),
				'dpdfg_pagination_active' => array(
					'label'           => __( 'Pagination Active', 'dpdfg-dp-divi-filtergrid' ),
					'css'             => array(
						'main'      => "{$this->main_css_element} .dp-dfg-pagination ul.pagination li.pagination-item.active a",
						'important' => 'all',
					),
					'hide_text_align' => true,
					'line_height'     => array( 'default' => '1.9em' ),
					'font_size'       => array( 'default' => '14px' ),
				),
			),
			'button'     => array(
				'read_more_button' => array(
					'label'         => __( 'Read More Button', 'dpdfg-dp-divi-filtergrid' ),
					'use_alignment' => true,
					'box_shadow'    => false,
					'css'           => array(
						'main'        => "{$this->main_css_element} .et_pb_button.dp-dfg-more-button",
						'plugin_main' => "{$this->main_css_element} .et_pb_button.dp-dfg-more-button",
						'alignment'   => "{$this->main_css_element} .dp-dfg-item .et_pb_button_wrapper",
					),
				),
				'load_more_button' => array(
					'label'         => __( 'Load More Button', 'dpdfg-dp-divi-filtergrid' ),
					'use_alignment' => true,
					'box_shadow'    => false,
					'css'           => array(
						'main'        => "{$this->main_css_element} .et_pb_button.dp-dfg-load-more-button",
						'plugin_main' => "{$this->main_css_element} .et_pb_button.dp-dfg-load-more-button",
						'alignment'   => "{$this->main_css_element} .dp-dfg-ajax-load-more .et_pb_button_wrapper",
					),
				),
			),
			'borders'    => array(
				'default' => array(
					'css'      => array(
						'main' => array(
							'border_radii'        => "{$this->main_css_element} .dp-dfg-container .dp-dfg-items .dp-dfg-item",
							'border_styles'       => "{$this->main_css_element} .dp-dfg-container .dp-dfg-items .dp-dfg-item",
							'border_styles_hover' => "{$this->main_css_element} .dp-dfg-container .dp-dfg-items .dp-dfg-item:hover",
						),
					),
					'defaults' => array(
						'border_radii'  => 'on||||',
						'border_styles' => array(
							'width' => '1px',
							'color' => '#d8d8d8',
							'style' => 'solid',
						),
					),
				),
			),
			'box_shadow' => array(
				'default' => array(
					'css' => array(
						'main' => "{$this->main_css_element} .dp-dfg-container .dp-dfg-items .dp-dfg-item",
					),
				),
			),
			'text'       => false,
			'filters'    => false,
		);
	}

	public function get_custom_css_fields_config() {
		return array(
			'dp-dfg-container'              => array(
				'label'    => __( 'Grid Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-container",
			),
			'dp-dfg-search'                 => array(
				'label'    => __( 'Search Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-search",
			),
			'dp-dfg-search-input'           => array(
				'label'    => __( 'Search Input', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-search-input",
			),
			'dp-dfg-search-icon'            => array(
				'label'    => __( 'Search Icon', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-search-icon",
			),
			'dp-dfg-filters'                => array(
				'label'    => __( 'Filters Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-filters",
			),
			'dp-dfg-levels'                 => array(
				'label'    => __( 'Levels Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} ul.dp-dfg-level",
			),
			'dp-dfg-dropdown-labels'        => array(
				'label'    => __( 'Level Dropdown Label', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-dropdown-label",
			),
			'dp-dfg-dropdown-tags'          => array(
				'label'    => __( 'Level Dropdown Tag', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-dropdown-tag",
			),
			'dp-dfg-filter'                 => array(
				'label'    => __( 'Filters', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-skin-default .dp-dfg-filter a.dp-dfg-filter-link",
			),
			'dp-dfg-filter_active'          => array(
				'label'    => __( 'Active Filter', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-skin-default .dp-dfg-filter a.dp-dfg-filter-link.active",
			),
			'dp-dfg-items'                  => array(
				'label'    => __( 'Posts Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-items",
			),
			'dp-dfg-item'                   => array(
				'label'    => __( 'Post Item Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-item",
			),
			'entry-thumb-container'         => array(
				'label'    => __( 'Post Thumbnail Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-image",
			),
			'entry-thumb'                   => array(
				'label'    => __( 'Thumbnail', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-image img",
			),
			'entry-overlay'                 => array(
				'label'    => __( 'Overlay', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-overlay",
			),
			'entry-header'                  => array(
				'label'    => __( 'Post Title Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-header",
			),
			'entry-meta'                    => array(
				'label'    => __( 'Post Meta Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-meta",
			),
			'entry-summary'                 => array(
				'label'    => __( 'Post Content Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-content",
			),
			'entry-button'                  => array(
				'label'    => __( 'Read More Button Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .et_pb_button_wrapper",
			),
			'entry-custom-content'          => array(
				'label'    => __( 'Custom Content Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-custom-content",
			),
			'dp-dfg-pagination'             => array(
				'label'    => __( 'Pagination Container', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-pagination",
			),
			'dp-dfg-pagination-link'        => array(
				'label'    => __( 'Pagination Item', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-skin-default .dp-dfg-pagination ul.pagination li.pagination-item",
			),
			'dp-dfg-pagination-link_active' => array(
				'label'    => __( 'Pagination Item Active', 'dpdfg-dp-divi-filtergrid' ),
				'selector' => "{$this->main_css_element} .dp-dfg-skin-default .dp-dfg-pagination ul.pagination li.pagination-item.active",
			),
		);
	}

	public function get_fields() {
		$query_fields          = array(
			/*
			 * Query options fields
			 */
			'custom_query'                => array(
				'label'           => __( 'Query Type', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'basic'    => __( 'Basic', 'dpdfg-dp-divi-filtergrid' ),
					'advanced' => __( 'Advanced', 'dpdfg-dp-divi-filtergrid' ),
					'archive'  => __( 'Archive Page', 'dpdfg-dp-divi-filtergrid' ),
					'custom'   => __( 'Custom', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'basic',
				'description'     => __( 'Choose between basic (posts only), advanced (multiple post type and taxonomy options), and custom (please review the <a target="_blank" href="https://diviplugins.com/documentation/divi-filtergrid/">documentation page</a> for instructions on adding custom content).', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'include_categories'          => array(
				'label'            => __( 'Include Categories', 'dpdfg-dp-divi-filtergrid' ),
				'type'             => 'categories',
				'option_category'  => 'configuration',
				'renderer_options' => array(
					'use_terms' => false,
				),
				'show_if'          => array( 'custom_query' => 'basic' ),
				'description'      => __( 'Choose which categories you would like to include in the feed.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'         => 'general',
				'toggle_slug'      => 'query_options',
			),
			'multiple_cpt'                => array(
				'label'           => __( 'Select Post Types', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => 'post',
				'show_if'         => array(
					'custom_query' => array(
						'advanced',
						'archive'
					)
				),
				'description'     => __( 'Click to select the post types you would like to display.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'use_taxonomy_terms'          => array(
				'label'           => __( 'Use Taxonomies', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'On', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'Off', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array( 'custom_query' => 'advanced' ),
				'description'     => __( 'Turn this option on to use taxonomies (categories, tags, etc.) to narrow the results. Leave this option off if you want to display all posts from the post type(s) above.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'multiple_taxonomies'         => array(
				'label'           => __( 'Select Taxonomies', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => 'category',
				'show_if'         => array(
					'custom_query'       => 'advanced',
					'use_taxonomy_terms' => 'on',
				),
				'description'     => __( 'Click to select the taxonomies you would like to include.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'taxonomies_relation'         => array(
				'label'           => __( 'Taxonomies Relation', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'OR'  => __( 'OR', 'dpdfg-dp-divi-filtergrid' ),
					'AND' => __( 'AND', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'OR',
				'show_if'         => array(
					'custom_query'       => 'advanced',
					'use_taxonomy_terms' => 'on',
				),
				'description'     => __( 'If you are using multiple taxonomies select the relation between all the taxonomies', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'include_terms'               => array(
				'label'           => __( 'Select Terms', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'show_if'         => array(
					'custom_query'       => 'advanced',
					'use_taxonomy_terms' => 'on',
				),
				'description'     => __( 'Click to select the terms you would like to include.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'terms_relation'              => array(
				'label'           => __( 'Terms Relation', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'IN'  => __( 'OR', 'dpdfg-dp-divi-filtergrid' ),
					'AND' => __( 'AND', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'IN',
				'show_if'         => array(
					'custom_query'       => 'advanced',
					'use_taxonomy_terms' => 'on',
				),
				'description'     => __( 'If you are using multiple terms select the relation between all terms of the same taxonomy.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'include_children_terms'      => array(
				'label'           => __( 'Include Child Terms', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'On', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'Off', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'on',
				'show_if'         => array(
					'custom_query'       => 'advanced',
					'use_taxonomy_terms' => 'on',
				),
				'description'     => __( 'Turn this option off to only display posts from the parent term. Leave this option on if you want to display posts from both parent and child terms.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'exclude_taxonomies'          => array(
				'label'           => __( 'Exclude Taxonomies', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => 'category',
				'show_if'         => array(
					'custom_query'       => 'advanced',
					'use_taxonomy_terms' => 'on',
				),
				'description'     => __( 'Click to select one or more taxonomies you would like to use to exclude posts.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'exclude_taxonomies_relation' => array(
				'label'           => __( 'Exclude Taxonomies Relation', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'AND' => __( 'AND', 'dpdfg-dp-divi-filtergrid' ),
					'OR'  => __( 'OR', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'OR',
				'show_if'         => array(
					'custom_query'       => 'advanced',
					'use_taxonomy_terms' => 'on',
				),
				'description'     => __( 'If you are using multiple exclude taxonomies select the relation between all the exclude taxonomies', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'exclude_terms'               => array(
				'label'           => __( 'Exclude Terms', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => '',
				'show_if'         => array(
					'custom_query'       => 'advanced',
					'use_taxonomy_terms' => 'on',
				),
				'description'     => __( 'Click to select one or more terms you would like to use to exclude posts.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'post_number'                 => array(
				'label'           => __( 'Post Number', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => '12',
				'show_if'         => array(
					'custom_query' => array(
						'archive',
						'advanced',
						'basic',
					),
				),
				'description'     => __( 'The number of posts to query for. Use -1 to request all posts.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'offset_number'               => array(
				'label'           => __( 'Offset Number', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => '0',
				'show_if'         => array(
					'custom_query' => array(
						'archive',
						'advanced',
						'basic',
					),
				),
				'description'     => __( 'Choose how many posts you would like to offset by.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'order'                       => array(
				'label'           => __( 'Order', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'ASC'  => __( 'Ascending', 'dpdfg-dp-divi-filtergrid' ),
					'DESC' => __( 'Descending', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'DESC',
				'show_if'         => array(
					'custom_query' => array(
						'archive',
						'advanced',
						'basic',
					),
				),
				'description'     => __( 'Choose to order posts in ascending or descending order.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'orderby'                     => array(
				'label'           => __( 'Order By', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'date'          => __( 'Date', 'dpdfg-dp-divi-filtergrid' ),
					'title'         => __( 'Title', 'dpdfg-dp-divi-filtergrid' ),
					'name'          => __( 'Slug', 'dpdfg-dp-divi-filtergrid' ),
					'rand'          => __( 'Random', 'dpdfg-dp-divi-filtergrid' ),
					'menu_order'    => __( 'Menu Order', 'dpdfg-dp-divi-filtergrid' ),
					'modified'      => __( 'Last Modified Date', 'dpdfg-dp-divi-filtergrid' ),
					'comment_count' => __( 'Comments Count', 'dpdfg-dp-divi-filtergrid' ),
					'parent'        => __( 'Parent ID', 'dpdfg-dp-divi-filtergrid' ),
					'type'          => __( 'Post Type', 'dpdfg-dp-divi-filtergrid' ),
					'author'        => __( 'Author', 'dpdfg-dp-divi-filtergrid' ),
					'meta_value'    => __( 'Custom Field', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'date',
				'show_if'         => array(
					'custom_query' => array(
						'archive',
						'advanced',
						'basic',
					),
				),
				'description'     => __( 'Choose a parameter to apply the order to.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'meta_key'                    => array(
				'label'           => __( 'Custom Field Name', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => '',
				'show_if'         => array(
					'custom_query' => array(
						'archive',
						'advanced',
						'basic',
					),
					'orderby'      => array( 'meta_value' ),
				),
				'description'     => __( 'Enter the custom field name.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'meta_type'                   => array(
				'label'           => __( 'Custom Field Type', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'NUMERIC',
					'BINARY',
					'CHAR',
					'DATE',
					'DATETIME',
					'DECIMAL',
					'SIGNED',
					'TIME',
					'UNSIGNED',
				),
				'default'         => 'CHAR',
				'show_if'         => array(
					'custom_query' => array(
						'archive',
						'advanced',
						'basic',
					),
					'orderby'      => array( 'meta_value' ),
				),
				'description'     => __( 'Enter the custom field type.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'show_private'                => array(
				'label'           => __( 'Show Private Posts', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'On', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'Off', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array(
					'custom_query' => array(
						'archive',
						'advanced',
						'basic',
					),
				),
				'description'     => __( 'Turn this option on to display private posts if user is logged in.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'sticky_posts'                => array(
				'label'           => __( 'Ignore Sticky Posts', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'On', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'Off', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array(
					'custom_query' => array(
						'advanced',
						'archive'
					)
				),
				'description'     => __( 'Turn this option on to ignore sticky posts. Currently sticky posts are not compatible with filters or pagination.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'remove_current_post'         => array(
				'label'           => __( 'Remove Current Post', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'On', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'Off', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array( 'custom_query' => 'advanced' ),
				'description'     => __( 'Turn on if you want to remove the current post. Useful if you want to show related content.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			),
			'no_results'                  => array(
				'label'           => __( 'Empty Results Text', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => __( 'No results found.', 'dpdfg-dp-divi-filtergrid' ),
				'description'     => __( 'Enter the text you would like to display when no results are found.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'query_options',
			)
		);
		$posts_elements_fields = array(
			/*
			 * Posts elements options
			 */
			'thumbnail_action'         => array(
				'label'           => __( 'Click Action', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'none'             => __( 'None', 'dpdfg-dp-divi-filtergrid' ),
					'link'             => __( 'Link to post', 'dpdfg-dp-divi-filtergrid' ),
					'popup'            => __( 'Show post in popup', 'dpdfg-dp-divi-filtergrid' ),
					'lightbox'         => __( 'Show feature image in lightbox', 'dpdfg-dp-divi-filtergrid' ),
					'lightbox_gallery' => __( 'Show all feature images in lightbox gallery', 'dpdfg-dp-divi-filtergrid' ),
					'gallery_cf'       => __( 'Open custom lightbox gallery', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'link',
				'description'     => __( 'Select the click action you would like to apply when the featured image, overlay or item is clicked. Don\'t apply to read more button and title link.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'gallery_cf_name'          => array(
				'label'           => __( 'Custom Field Name for Images', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => '',
				'show_if'         => array( 'thumbnail_action' => 'gallery_cf' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
				'description'     => __( 'Enter the custom field name containing the image or array of images you would like to load in the custom lightbox gallery. Leave this empty to use the <a href="https://diviplugins.com/documentation/divi-filtergrid/custom-lightbox/">Custom Lightbox filter</a>.', 'dpdfg-dp-divi-filtergrid' ),
			),
			'show_thumbnail'           => array(
				'label'           => __( 'Show Featured Image', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'on',
				'description'     => __( 'This will turn thumbnails on and off.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'thumbnail_size'           => array(
				'label'           => __( 'Thumbnail Size', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => Dp_Dfg_Utils::get_registered_thumbnail_sizes(),
				'default'         => '400x284',
				'show_if'         => array( 'show_thumbnail' => 'on' ),
				'description'     => __( 'Select the thumbnail size.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'use_overlay'              => array(
				'label'           => __( 'Overlay', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => esc_html__( 'Off', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => esc_html__( 'On', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'on',
				'description'     => esc_html__( 'If enabled, an overlay color and icon will be displayed when a visitor hovers over the featured image of a post.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'overlay_icon_color'       => array(
				'label'        => esc_html__( 'Overlay Icon Color', 'dpdfg-dp-divi-filtergrid' ),
				'type'         => 'color-alpha',
				'custom_color' => true,
				'default'      => '#2ea3f2',
				'show_if'      => array( 'use_overlay' => 'on' ),
				'description'  => esc_html__( 'Here you can define a custom color for the overlay icon', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'     => 'general',
				'toggle_slug'  => 'elements_options',
			),
			'hover_overlay_color'      => array(
				'label'        => esc_html__( 'Hover Overlay Color', 'dpdfg-dp-divi-filtergrid' ),
				'type'         => 'color-alpha',
				'custom_color' => true,
				'default'      => 'rgba(255,255,255,0.9)',
				'show_if'      => array( 'use_overlay' => 'on' ),
				'description'  => esc_html__( 'Here you can define a custom color for the overlay', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'     => 'general',
				'toggle_slug'  => 'elements_options',
			),
			'hover_icon'               => array(
				'label'           => esc_html__( 'Hover Icon Picker', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select_icon',
				'option_category' => 'configuration',
				'class'           => array( 'et-pb-font-icon' ),
				'default'         => '%%200%%',
				'show_if'         => array( 'use_overlay' => 'on' ),
				'description'     => esc_html__( 'Here you can define a custom icon for the overlay', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'show_title'               => array(
				'label'           => __( 'Show Title', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'on',
				'description'     => __( 'Turn on or off the title.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'title_link'               => array(
				'label'           => __( 'Add Link to Title', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array( 'show_title' => 'on' ),
				'description'     => __( 'Turn this option on if you want the title to link to the post or the custom URL.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'show_post_meta'           => array(
				'label'           => __( 'Show Post meta', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'on',
				'description'     => __( 'Turn on or off the post meta information.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'show_author'              => array(
				'label'           => __( 'Show Author', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'on',
				'show_if'         => array( 'show_post_meta' => 'on' ),
				'description'     => __( 'Turn on or off the author link.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'author_prefix_text'       => array(
				'label'           => __( 'Author Prefix', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => __( 'By ', 'dpdfg-dp-divi-filtergrid' ),
				'show_if'         => array(
					'show_post_meta' => 'on',
					'show_author'    => 'on',
				),
				'description'     => __( 'Custom prefix displayed before author name.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'show_date'                => array(
				'label'           => __( 'Show Date', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array( 'show_post_meta' => 'on' ),
				'description'     => __( 'Turn the date on or off.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'date_format'              => array(
				'label'       => __( 'Date Format', 'dpdfg-dp-divi-filtergrid' ),
				'type'        => 'text',
				'show_if'     => array(
					'show_post_meta' => 'on',
					'show_date'      => 'on',
				),
				'default'     => get_option( 'date_format' ),
				'description' => __( 'Define the date format. <a target="_blank" href="https://codex.wordpress.org/Formatting_Date_and_Time">Documentation on date and time formatting</a>.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'    => 'general',
				'toggle_slug' => 'elements_options',
			),
			'show_terms'               => array(
				'label'           => __( 'Show Terms', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array( 'show_post_meta' => 'on' ),
				'description'     => __( 'Turn the terms links on or off (categories, tags, etc.)', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'show_terms_taxonomy'      => array(
				'label'           => __( 'Show Terms Taxonomy', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => 'category',
				'show_if'         => array(
					'show_post_meta' => 'on',
					'show_terms'     => 'on',
				),
				'description'     => __( 'Show terms of specific taxonomies. Let blank to show all terms.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'show_comments'            => array(
				'label'           => __( 'Show Comment Count', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array( 'show_post_meta' => 'on' ),
				'description'     => __( 'Turn comment count on or off.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'show_content'             => array(
				'label'           => __( 'Show Excerpt', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'description'     => __( 'Turn the post excerpt on or off.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'truncate_content'         => array(
				'label'           => __( 'Limit Excerpt', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'default'         => '120',
				'option_category' => 'configuration',
				'show_if'         => array( 'show_content' => 'on' ),
				'description'     => __( 'Enter the number of characters you would like to limit the excerpt to for posts that do not have an excerpt. This will not apply to posts that have an excerpt.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'read_more'                => array(
				'label'           => __( 'Show Read More Button', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'description'     => __( 'Turn read more button on or off.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'read_more_text'           => array(
				'label'           => __( 'Read More Text', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => __( 'Read More', 'dpdfg-dp-divi-filtergrid' ),
				'show_if'         => array( 'read_more' => 'on' ),
				'description'     => __( 'Custom text for the read more button.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'read_more_window'         => array(
				'label'           => __( 'Link Target', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'Same Window', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'New Tab', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'description'     => __( 'Here you can choose whether or not your link opens in a new window', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'show_custom_fields'       => array(
				'label'           => __( 'Show Custom Fields', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'description'     => __( 'Turn custom fields on or off', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'custom_fields'            => array(
				'label'           => __( 'Custom Fields', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => '',
				'show_if'         => array( 'show_custom_fields' => 'on' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'show_custom_content'      => array(
				'label'           => __( 'Show Custom Content', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'description'     => __( 'Turn custom content on or off. Please review the <a target="_blank" href="https://diviplugins.com/documentation/divi-filtergrid/">documentation page</a> for instructions on adding custom content.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'custom_content_container' => array(
				'label'           => __( 'Custom Content / Custom Fields Wrapper', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'on',
				'description'     => __( 'Turn this option off to remove the "dp-dfg-custom-content" wrapper, allowing you to create your own wrappers for different pieces of content and more placement options using CSS Grid.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'custom_url'               => array(
				'label'           => __( 'Use Custom URLs', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'description'     => __( 'Changes the URL to a custom field value set in each post.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'elements_options',
			),
			'custom_url_field_name'    => array(
				'label'       => __( 'Custom Field for URL', 'dpdfg-dp-divi-filtergrid' ),
				'type'        => 'text',
				'show_if'     => array( 'custom_url' => 'on' ),
				'description' => __( 'Enter custom field name (NOT the URL). The URL value needs to be set in each post using the custom field you input here. If no value is set, defaults to post URL.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'    => 'general',
				'toggle_slug' => 'elements_options',
			),
		);
		$filters_fields        = array(
			/*
			 * Filters options fields
			 */
			'show_filters'                => array(
				'label'           => __( 'Show Filters', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'on',
				'description'     => __( 'Turn this option off if you do not want to give visitors the option to filter the results from the query above.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'filter_layout'               => array(
				'label'           => __( 'Filters Layout', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'button' => __( 'Buttons', 'dpdfg-dp-divi-filtergrid' ),
					'select' => __( 'Dropdown', 'dpdfg-dp-divi-filtergrid' )
				),
				'default'         => 'button',
				'show_if'         => array(
					'show_filters' => 'on',
				),
				'description'     => __( 'Chose which layout you want to use for the filters.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'filter_dropdown_show_tags'   => array(
				'label'           => __( 'Show Placeholder Active Filters', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'on',
				'show_if'         => array(
					'show_filters'  => 'on',
					'filter_layout' => 'select',
				),
				'description'     => __( 'Turn this option on if you want to show active terms for the filter dropdown layout.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'filter_dropdown_placeholder' => array(
				'label'           => __( 'Dropdown Layout Text', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => __( 'Select the terms', 'dpdfg-dp-divi-filtergrid' ),
				'show_if'         => array(
					'show_filters'  => 'on',
					'filter_layout' => 'select',
					'multilevel'    => 'off',
				),
				'description'     => __( 'Default text for the dropdown filter layout', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'multifilter'                 => array(
				'label'           => __( 'Use MultiSelect Filters', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array(
					'show_filters' => 'on'
				),
				'description'     => __( 'Turn this option on if you would like to allow users to select more than one filter at a time.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'multifilter_relation'        => array(
				'label'           => __( 'MultiSelect Filters Relation', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'OR'  => __( 'OR', 'dpdfg-dp-divi-filtergrid' ),
					'AND' => __( 'AND', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'OR',
				'show_if'         => array(
					'show_filters' => 'on',
					'multifilter'  => 'on',
				),
				'description'     => __( 'Choose if posts need to have only 1 active filter (OR) to display or if posts need to have all active filters (AND).', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'multilevel'                  => array(
				'label'           => __( 'Use MultiLevel Filters', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array(
					'show_filters' => 'on',
				),
				'show_if_not'     => array( 'custom_query' => 'basic' ),
				'description'     => __( 'Turn this option on to add more than one level of filters.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'multilevel_relation'         => array(
				'label'           => __( 'MultiLevel Filters Relation', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'OR'  => __( 'OR', 'dpdfg-dp-divi-filtergrid' ),
					'AND' => __( 'AND', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'AND',
				'show_if'         => array(
					'show_filters' => 'on',
					'multilevel'   => 'on',
				),
				'show_if_not'     => array( 'custom_query' => 'basic' ),
				'description'     => __( 'Choose if posts need to have an active filter in each level (AND) or if posts need to have only 1 active filter in any level (OR).', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'multilevel_tax_data'         => array(
				'label'           => __( 'MultiLevel Taxonomies', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => '',
				'show_if'         => array(
					'show_filters' => 'on',
					'multilevel'   => 'on',
				),
				'show_if_not'     => array( 'custom_query' => 'basic' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'use_custom_terms_filters'    => array(
				'label'           => __( 'Use Custom Filters', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array( 'show_filters' => 'on' ),
				'description'     => __( 'Turn this option on to bypass the filter options below and add the filters manually using our Custom Filters filter. For more information and examples, please visit the documentation page at <a href="https://diviplugins.com/documentation/divi-filtergrid/custom-filters/" target="_blank">Divi Plugins</a>.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'filter_taxonomies'           => array(
				'label'           => __( 'Filter Taxonomies', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => 'category',
				'show_if'         => array(
					'show_filters'             => 'on',
					'use_custom_terms_filters' => 'off',
					'multilevel'               => 'off',
				),
				'show_if_not'     => array( 'custom_query' => 'basic' ),
				'description'     => __( 'Click to select the taxonomies you would like to include in the filters.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'filter_terms'                => array(
				'label'           => __( 'Filter Terms', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => '',
				'show_if'         => array(
					'show_filters'             => 'on',
					'use_custom_terms_filters' => 'off',
				),
				'show_if_not'     => array( 'custom_query' => 'basic' ),
				'description'     => __( 'Click to select the terms you would like to include in the filters. Leave this field empty if you would like to include all terms from the taxonomies chosen above.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'default_filter'              => array(
				'label'           => __( 'Default Filter', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => 'All',
				'show_if'         => array(
					'show_filters'             => 'on',
					'use_custom_terms_filters' => 'off',
				),
				'description'     => __( 'Click to select the term you want active by default when the page first loads. Leave blank to display all posts from the query above by default. This option is not currently compatible with the Cache Filter & Pagination Results option. Cache will be disabled if a default filter is set.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'hide_all'                    => array(
				'label'           => __( 'Hide All Filter Button', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array(
					'show_filters'             => 'on',
					'use_custom_terms_filters' => 'off',
				),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'all_text'                    => array(
				'label'           => __( 'All Text', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => 'All',
				'show_if'         => array(
					'show_filters'             => 'on',
					'hide_all'                 => 'off',
					'use_custom_terms_filters' => 'off',
				),
				'description'     => __( 'Here you can change the default text used for the All filter button.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'filters_order'               => array(
				'label'           => __( 'Filters Order', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'ASC'  => __( 'Ascending', 'dpdfg-dp-divi-filtergrid' ),
					'DESC' => __( 'Descending', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'ASC',
				'show_if'         => array(
					'show_filters'             => 'on',
					'filters_sort'             => array(
						'id',
						'name',
					),
					'use_custom_terms_filters' => 'off',
				),
				'description'     => __( 'Choose to order filters in ascending or descending order.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'filters_sort'                => array(
				'label'           => __( 'Filters Order By', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'id'         => __( 'ID', 'dpdfg-dp-divi-filtergrid' ),
					'name'       => __( 'Name', 'dpdfg-dp-divi-filtergrid' ),
					'slug'       => __( 'Slug', 'dpdfg-dp-divi-filtergrid' ),
					'term_group' => __( 'Menu Order', 'dpdfg-dp-divi-filtergrid' ),
					'custom'     => __( 'Custom Order', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'id',
				'show_if'         => array(
					'show_filters'             => 'on',
					'use_custom_terms_filters' => 'off',
				),
				'description'     => __( 'Choose a parameter to apply the order to.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
			'filters_custom'              => array(
				'label'           => __( 'Filters Custom', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'textarea',
				'option_category' => 'configuration',
				'show_if'         => array(
					'show_filters'             => 'on',
					'filters_sort'             => 'custom',
					'use_custom_terms_filters' => 'off',
				),
				'description'     => __( 'Enter a comma-separated list of filters name. Filters will appear in the order you enter them.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'filter_options',
			),
		);
		$pagination_fields     = array(
			/*
			 * Pagination fields
			 */
			'show_pagination'     => array(
				'label'           => __( 'Activate Pagination', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'on',
				'description'     => __( 'Turn this option off if you want to limit the number of posts returned to the Post Number value above. Leave this option on if you want to give users the ability to load more posts.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'pagination_type'     => array(
				'label'           => __( 'Pagination Type', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'paged'  => __( 'Paged', 'dpdfg-dp-divi-filtergrid' ),
					'button' => __( 'Load more button', 'dpdfg-dp-divi-filtergrid' ),
					'scroll' => __( 'Load more on scroll', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'paged',
				'show_if'         => array( 'show_pagination' => 'on' ),
				'description'     => __( 'Select the method to load additional posts.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'ajax_load_more_text' => array(
				'label'           => __( 'Load More Text', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => __( 'Load More', 'dpdfg-dp-divi-filtergrid' ),
				'show_if'         => array(
					'show_pagination' => 'on',
					'pagination_type' => 'button',
				),
				'description'     => __( 'Custom text for the load more button.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'previous_icon'       => array(
				'label'           => __( 'Previous Icon', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select_icon',
				'option_category' => 'configuration',
				'show_if'         => array(
					'show_pagination' => 'on',
					'pagination_type' => 'paged',
				),
				'class'           => array( 'et-pb-font-icon' ),
				'default'         => '%%19%%',
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'next_icon'           => array(
				'label'           => __( 'Next Icon', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select_icon',
				'option_category' => 'configuration',
				'show_if'         => array(
					'show_pagination' => 'on',
					'pagination_type' => 'paged',
				),
				'class'           => array( 'et-pb-font-icon' ),
				'default'         => '%%20%%',
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'previous_text'       => array(
				'label'           => __( 'Previous Text', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => '',
				'show_if'         => array(
					'show_pagination' => 'on',
					'pagination_type' => 'paged',
				),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'next_text'           => array(
				'label'           => __( 'Next Text', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => '',
				'show_if'         => array(
					'show_pagination' => 'on',
					'pagination_type' => 'paged',
				),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'pagination_pages'    => array(
				'label'           => __( 'Pagination Pages', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => 2,
				'show_if'         => array(
					'show_pagination' => 'on',
					'pagination_type' => 'paged',
				),
				'description'     => __( 'Number of pages to show before and after the active page on the pagination.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'first_last'          => array(
				'label'           => __( 'Activate First/Last Buttons', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'show_if'         => array(
					'show_pagination' => 'on',
					'pagination_type' => 'paged',
				),
				'description'     => __( 'Add first and last page buttons to the pagination.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'first_icon'          => array(
				'label'           => __( 'First Icon', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select_icon',
				'option_category' => 'configuration',
				'show_if'         => array(
					'show_pagination' => 'on',
					'pagination_type' => 'paged',
					'first_last'      => 'on',
				),
				'class'           => array( 'et-pb-font-icon' ),
				'default'         => '%%23%%',
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'last_icon'           => array(
				'label'           => __( 'Next Icon', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select_icon',
				'option_category' => 'configuration',
				'show_if'         => array(
					'show_pagination' => 'on',
					'pagination_type' => 'paged',
					'first_last'      => 'on',
				),
				'class'           => array( 'et-pb-font-icon' ),
				'default'         => '%%24%%',
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'first_text'          => array(
				'label'           => __( 'First Text', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => '',
				'show_if'         => array(
					'show_pagination' => 'on',
					'pagination_type' => 'paged',
					'first_last'      => 'on',
				),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
			'last_text'           => array(
				'label'           => __( 'Last Text', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => '',
				'show_if'         => array(
					'show_pagination' => 'on',
					'pagination_type' => 'paged',
					'first_last'      => 'on',
				),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'pagination_options',
			),
		);
		$search_fields         = array(
			/*
			 * Pagination fields
			 */
			'show_search'        => array(
				'label'           => __( 'Activate Search', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'description'     => __( 'Turn this option on if you want to give visitors the ability to search results', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'search_options',
			),
			'search_placeholder' => array(
				'label'           => __( 'Placeholder Text', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'default'         => __( 'Search', 'dpdfg-dp-divi-filtergrid' ),
				'show_if'         => array(
					'show_search' => 'on'
				),
				'description'     => __( 'Custom text for search placeholder', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'search_options',
			),
			'search_position'    => array(
				'label'           => __( 'Search Position', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'above' => __( 'Above Filters', 'dpdfg-dp-divi-filtergrid' ),
					'below' => __( 'Below Filters', 'dpdfg-dp-divi-filtergrid' ),
					'left'  => __( 'Left of Filters  (dropdown filters only)', 'dpdfg-dp-divi-filtergrid' ),
					'right' => __( 'Right of Filters  (dropdown filters only)', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'above',
				'show_if'         => array(
					'show_search'  => 'on',
					'show_filters' => 'on'
				),
				'description'     => __( 'Choose to display the search box above or below the filters', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'search_options',
			)
		);
		$layout_fields         = array(
			/*
			 * Layout options fields
			 */
			'filters_width'   => array(
				'label'           => __( 'Dropdown Filters Columns', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'mobile_options'  => true,
				'default'         => '4',
				'show_if'         => array(
					'filter_layout' => array(
						'select'
					)
				),
				'responsive'      => true,
				'description'     => __( 'Define how many columns each row of filters should have.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'layout_options',
			),
			'items_layout'    => array(
				'label'           => __( 'Select a Layout', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'dp-dfg-layout-grid'      => __( 'Grid', 'dpdfg-dp-divi-filtergrid' ),
					'dp-dfg-layout-list'      => __( 'List', 'dpdfg-dp-divi-filtergrid' ),
					'dp-dfg-layout-fullwidth' => __( 'Fullwidth', 'dpdfg-dp-divi-filtergrid' ),
					'dp-dfg-layout-masonry'   => __( 'Masonry', 'dpdfg-dp-divi-filtergrid' ),
					'dp-dfg-layout-none'      => __( 'None', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'dp-dfg-layout-grid',
				'description'     => __( 'Choose a layout to display the posts.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'layout_options',
			),
			'items_skin'      => array(
				'label'           => __( 'Select a Skin', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => Dp_Dfg_Utils::get_skins(),
				'default'         => 'dp-dfg-skin-default',
				'description'     => __( 'Select a skin to apply different visual effects to the posts.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'layout_options',
			),
			'thumb_min_width' => array(
				'label'           => __( 'Image Min Width', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'range',
				'option_category' => 'configuration',
				'mobile_options'  => true,
				'validate_unit'   => true,
				'default'         => '300px',
				'default_unit'    => 'px',
				'allow_empty'     => false,
				'range_settings'  => array(
					'min'  => '0',
					'max'  => '400',
					'step' => '1',
				),
				'show_if'         => array( 'items_layout' => 'dp-dfg-layout-list' ),
				'responsive'      => true,
				'description'     => __( 'Define the minimum width of the image. The image will never be smaller than this value.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'layout_options',
			),
			'thumb_width'     => array(
				'label'           => __( 'Image Max Width', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'range',
				'option_category' => 'configuration',
				'mobile_options'  => true,
				'validate_unit'   => true,
				'default'         => '33%',
				'default_unit'    => '%',
				'allow_empty'     => false,
				'range_settings'  => array(
					'min'  => '0',
					'max'  => '100',
					'step' => '1',
				),
				'show_if'         => array( 'items_layout' => 'dp-dfg-layout-list' ),
				'responsive'      => true,
				'description'     => __( 'Define the maximum width of the image in relation to the total width of the item. The image will always be as wide as this value unless this value is smaller than the minimum width set above.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'layout_options',
			),
			'items_width'     => array(
				'label'           => __( 'Items Width', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'range',
				'option_category' => 'configuration',
				'mobile_options'  => true,
				'validate_unit'   => true,
				'default'         => '20%',
				'default_unit'    => '%',
				'allow_empty'     => false,
				'range_settings'  => array(
					'min'  => '0',
					'max'  => '100',
					'step' => '1',
				),
				'show_if'         => array(
					'items_layout' => array(
						'dp-dfg-layout-grid',
						'dp-dfg-layout-masonry'
					)
				),
				'responsive'      => true,
				'description'     => __( 'Define the width of each post item in the grid. This value is combined with the Column & Row Gutter value below to determine how many columns the grid will have for each screen size.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'layout_options',
			),
			'column_gutter'   => array(
				'label'           => __( 'Column Gutter', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'range',
				'option_category' => 'configuration',
				'mobile_options'  => true,
				'validate_unit'   => true,
				'default'         => '2em',
				'default_unit'    => 'em',
				'allow_empty'     => false,
				'range_settings'  => array(
					'min'  => '0',
					'max'  => '10',
					'step' => '1',
				),
				'show_if'         => array(
					'items_layout' => array(
						'dp-dfg-layout-grid',
						'dp-dfg-layout-list',
						'dp-dfg-layout-masonry'
					),
				),
				'responsive'      => true,
				'description'     => __( 'Define the gap between each column in the grid.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'layout_options',
			),
			'row_gutter'      => array(
				'label'           => __( 'Row Gutter', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'range',
				'option_category' => 'configuration',
				'mobile_options'  => true,
				'validate_unit'   => true,
				'default'         => '2em',
				'default_unit'    => 'em',
				'allow_empty'     => false,
				'range_settings'  => array(
					'min'  => '0',
					'max'  => '10',
					'step' => '1',
				),
				'show_if'         => array(
					'items_layout' => array(
						'dp-dfg-layout-grid',
						'dp-dfg-layout-list',
						'dp-dfg-layout-masonry'
					),
				),
				'responsive'      => true,
				'description'     => __( 'Define the gap between each row in the grid', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'layout_options',
			),
			'grid_font_size'  => array(
				'label'           => __( 'Grid Font Size', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'range',
				'option_category' => 'configuration',
				'mobile_options'  => true,
				'validate_unit'   => true,
				'default'         => '10px',
				'default_unit'    => 'px',
				'allow_empty'     => false,
				'range_settings'  => array(
					'min'  => '0',
					'max'  => '100',
					'step' => '1',
				),
				'show_if'         => array(
					'items_layout' => array(
						'dp-dfg-layout-grid',
						'dp-dfg-layout-list',
						'dp-dfg-layout-fullwidth',
					),
				),
				'responsive'      => true,
				'description'     => __( 'All font sizes, padding, margins, gaps, etc. are based on the grid font size. Changing this value will change these values throughout the entire grid.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'layout_options',
			),
		);
		$cache_fields          = array(
			/*
			 * Cache Fields
			 */
			'cache_on_page' => array(
				'label'           => __( 'Cache Filter & Pagination Results', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'yes_no_button',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => __( 'No', 'dpdfg-dp-divi-filtergrid' ),
					'on'  => __( 'Yes', 'dpdfg-dp-divi-filtergrid' ),
				),
				'default'         => 'off',
				'description'     => __( 'Turn this option on to enable filter and pagination caching. Please review the <a href="https://diviplugins.com/documentation/divi-filtergrid/caching/">documentation page</a> for more information on this option.', 'dpdfg-dp-divi-filtergrid' ),
				'tab_slug'        => 'general',
				'toggle_slug'     => 'cache_options',
			),
		);
		$background_fields     = array(
			/*
			 * Background Fields
			 */
			'bg_search'            => array(
				'label'           => __( 'Search Input Background', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'color-alpha',
				'option_category' => 'configuration',
				'custom_color'    => true,
				'tab_slug'        => 'general',
				'toggle_slug'     => 'background',
			),
			'bg_search_icon'       => array(
				'label'           => __( 'Search Icon Background', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'color-alpha',
				'option_category' => 'configuration',
				'custom_color'    => true,
				'tab_slug'        => 'general',
				'toggle_slug'     => 'background',
			),
			'bg_items'             => array(
				'label'           => __( 'Grid Item Background', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'color-alpha',
				'option_category' => 'configuration',
				'custom_color'    => true,
				'tab_slug'        => 'general',
				'toggle_slug'     => 'background',
			),
			'bg_filters'           => array(
				'label'           => __( 'Filters Background', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'color-alpha',
				'option_category' => 'configuration',
				'custom_color'    => true,
				'tab_slug'        => 'general',
				'toggle_slug'     => 'background',
			),
			'bg_filter_active'     => array(
				'label'           => __( 'Active Filter Background', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'color-alpha',
				'option_category' => 'configuration',
				'custom_color'    => true,
				'tab_slug'        => 'general',
				'toggle_slug'     => 'background',
			),
			'bg_pagination'        => array(
				'label'           => __( 'Pagination Background', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'color-alpha',
				'option_category' => 'configuration',
				'custom_color'    => true,
				'tab_slug'        => 'general',
				'toggle_slug'     => 'background',
			),
			'bg_pagination_active' => array(
				'label'           => __( 'Pagination Active Background', 'dpdfg-dp-divi-filtergrid' ),
				'type'            => 'color-alpha',
				'option_category' => 'configuration',
				'custom_color'    => true,
				'tab_slug'        => 'general',
				'toggle_slug'     => 'background',
			),
		);

		return array_merge( $query_fields, $posts_elements_fields, $filters_fields, $pagination_fields, $layout_fields, $search_fields, $cache_fields, $background_fields );
	}

	public function before_render() {
		parent::before_render();
		wp_enqueue_script( 'dp-divi-filtergrid-frontend-bundle' );
		if ( 'dp-dfg-layout-masonry' === $this->props['items_layout'] ) {
			wp_enqueue_script( "dp-divi-filtergrid-imagesloaded", DPDFG_URL . 'vendor/imagesloaded.pkgd.min.js', array(), DPDFG_VERSION, true );
		}
		/*
		* Custom loader
		*/
		$loader_html = apply_filters( 'dpdfg_custom_loader', '<div class="et-fb-loader-wrapper dp-dfg-loader"><div class="et-fb-loader"></div></div>' );
		/*
		 * Localize script
		 */
		wp_localize_script(
			'dp-divi-filtergrid-frontend-bundle',
			'dpdfg',
			array(
				'loader_html' => $loader_html,
				'ajaxurl'     => admin_url( 'admin-ajax.php' ),
				'nonce'       => wp_create_nonce( 'dpdfg_get_posts_data_action' )
			)
		);
	}

	public function render( $attrs, $content = null, $render_slug ) {
		$props                     = $this->props;
		$props['the_ID']           = get_queried_object_id();
		$props['conditional_tags'] = array(
			'is_user_logged_in' => is_user_logged_in() ? 'on' : 'off',
			'is_front_page'     => is_front_page() ? 'on' : 'off',
			'is_singular'       => is_singular() ? 'on' : 'off',
			'is_archive'        => is_archive() ? 'on' : 'off',
			'is_search'         => is_search() ? 'on' : 'off',
			'is_tax'            => is_tax() || is_category() || is_tag() ? 'on' : 'off',
			'is_author'         => is_author() ? 'on' : 'off',
			'is_date'           => is_date() ? 'on' : 'off',
			'is_post_type'      => is_post_type_archive() ? 'on' : 'off',
		);
		$props['query_var']        = array(
			's'         => get_search_query(),
			'year'      => esc_attr( get_query_var( 'year' ) ),
			'monthnum'  => esc_attr( get_query_var( 'monthnum' ) ),
			'day'       => esc_attr( get_query_var( 'day' ) ),
			'post_type' => esc_attr( get_query_var( 'post_type' ) ),
		);
		$props['custom_data']      = apply_filters( 'dpdfg_module_custom_data', array(), $props );
		/*
		 * Responsive CSS
		 */
		$this->responsive_css( $props, $props['items_layout'], $render_slug );
		/*
		 * Deactivating cache
		 */
		if ( 'All' !== $props['default_filter'] || 'on' === $props['multifilter'] || 'on' === $props['multilevel'] ) {
			$props['cache_on_page'] = 'off';
		}
		/*
		 * Filters init
		 */
		if ( 'All' !== $props['default_filter'] ) {
			$props['active_filter']      = $props['default_filter'];
			$props['use_taxonomy_terms'] = 'on';
		}
		/*
		* Override filter taxonomies if Use Custom Filters is active
		*/
		if ( 'on' === $props['use_custom_terms_filters'] ) {
			$props['filter_taxonomies'] = apply_filters( 'dpdfg_custom_filters_taxonomies', $props['filter_taxonomies'], $props );
		}
		/*
		 * Init Query
		 */
		if ( get_query_var( 'paged' ) ) {
			$page = get_query_var( 'paged' );
		} elseif ( get_query_var( 'page' ) ) {
			$page = get_query_var( 'page' );
		} else {
			$page = 1;
		}
		$posts_data = Dp_Dfg_Utils::get_posts_data( $props, $page, 'init' );
		/*
		 * Init output
		 */
		ob_start();
		if ( isset( $posts_data['error'] ) ) {
			echo et_core_intentionally_unescaped( sprintf( '<div class="dp-dfg-container"><p class="dp-dfg-error">%1$s</p></div>', $posts_data['error'] ), 'html' );
		} elseif ( isset( $posts_data['no_results'] ) ) {
			echo et_core_intentionally_unescaped( sprintf( '<div class="dp-dfg-container"><div class="dp-dfg-items"></div>%1$s</div>', $posts_data['no_results'] ), 'html' );
		} else {
			$posts_number          = ( 'custom' !== $props['custom_query'] ) ? $props['post_number'] : $posts_data['post_number'];
			$layout                = ( 'dp-dfg-layout-masonry' === $props['items_layout'] ) ? 'dp-dfg-layout-grid dp-dfg-layout-masonry' : $props['items_layout'];
			$main_class            = esc_attr( 'dp-dfg-container ' . $layout . ' ' . $props['items_skin'] );
			$active_filter_by_link = '';
			if ( isset( $_SERVER['REQUEST_URI'] ) ) {
				$request_uri = esc_url_raw( wp_unslash( $_SERVER['REQUEST_URI'] ) );
				$query       = wp_parse_url( $request_uri );
				if ( isset( $query['query'] ) ) {
					parse_str( $query['query'], $query );
					if ( isset( $query['dfg_active_filter'] ) ) {
						$active_filter_by_link = $query['dfg_active_filter'];
					}
				}
			}
			$active_filter = ( isset( $props['default_filter'] ) && intval( $props['default_filter'] ) ) ? intval( $props['default_filter'] ) : 'all';
			/*
			 * Localize module properties
			 */
			$module_class = trim( ET_Builder_Element::add_module_order_class( '', $render_slug ) );
			wp_localize_script(
				'dp-divi-filtergrid-frontend-bundle',
				$module_class,
				array(
					'no_results' => sprintf( '<div class="dp-dfg-no-results">%1$s</div>', et_core_intentionally_unescaped( $props['no_results'], 'html' ) ),
					'props'      => $this->get_data_module_for_ajax( $props )
				)
			);
			/*
			 * Main Container
			 */
			echo et_core_intentionally_unescaped(
				sprintf(
					'<!-- DPDFG Start Main Container --><div class="%2$s" data-active-filter="%3$s" data-page="%4$s" data-found-posts="%5$s" data-post-number="%6$s" data-default-filter="%7$s" data-link-filter="%8$s" data-cache="%9$s" data-ratio="%10$s" data-show-thumb="%11$s" data-action="%12$s" data-new-window="%13$s" data-multifilter="%14$s|%15$s" data-multilevel="%16$s|%17$s" doing-ajax="off" data-module="%1$s" data-search ="%18$s" data-search-position="%19$s" data-filters="%20$s" data-terms-tags="%21$s">',
					$module_class,
					$main_class,
					$active_filter,
					intval( $page ),
					intval( $posts_data['found_posts'] ),
					intval( $posts_number ),
					esc_attr( $props['default_filter'] ),
					esc_attr( $active_filter_by_link ),
					esc_attr( $props['cache_on_page'] ),
					esc_attr( $posts_data['ratio'] ),
					esc_attr( $props['show_thumbnail'] ),
					esc_attr( $props['thumbnail_action'] ),
					esc_attr( $props['read_more_window'] ),
					esc_attr( $props['multifilter'] ),
					esc_attr( $props['multifilter_relation'] ),
					esc_attr( $props['multilevel'] ),
					esc_attr( $props['multilevel_relation'] ),
					esc_attr( $props['show_search'] ),
					esc_attr( $props['search_position'] ),
					esc_attr( $props['show_filters'] ),
					esc_attr( $props['filter_dropdown_show_tags'] )
				),
				'html'
			);
			/*
			 * Search
			 */
			$search_output = '';
			if ( 'on' === $props['show_search'] ) {
				$search_icon   = esc_attr( et_pb_process_font_icon( '%%52%%' ) );
				$clear_icon    = esc_attr( et_pb_process_font_icon( '%%48%%' ) );
				$search_button = sprintf( '<span class="dp-dfg-search-icon" data-icon-search="%1$s" data-icon-clear="%2$s">%1$s</span>', $search_icon, $clear_icon );
				$search_output = sprintf( '<input class="dp-dfg-search-input" type="search" placeholder="%1$s" />%2$s', $props['search_placeholder'], $search_button );
				$search_output = et_core_intentionally_unescaped( sprintf( '<div class="dp-dfg-search">%1$s</div><!-- DPDFG End Search Container -->', $search_output ), 'html' );
			}
			/*
			 * Filters
			 */
			$filters_output = '';
			if ( 'on' === $props['show_filters'] ) {
				$filters             = Dp_Dfg_Utils::get_filter_terms( $props, $posts_data['posts'] );
				$filters_levels      = $filters['levels'];
				$filters_data        = $filters['levels_data'];
				$levels_counter      = 0;
				$filter_layout_class = "dp-dfg-filters-buttons-layout";
				switch ( $props['filter_layout'] ) {
					case 'button':
						foreach ( $filters_levels as $filter_tax => $filter_level ) {
							$label_output = '';
							if ( is_array( $filters_data ) && isset( $filters_data[ $filter_tax ] ) && '' !== $filters_data[ $filter_tax ]['label'] ) {
								$label_output = sprintf( '<p class="dp-dfg-taxonomy-label dp-dfg-taxonomy-%2$s">%1$s</p>', $filters_data[ $filter_tax ]['label'], $filters_data[ $filter_tax ]['name'] );
							}
							$buttons_output = '';
							foreach ( $filter_level as $filter ) {
								$buttons_output .= sprintf( '<li class="dp-dfg-filter"><a class="dp-dfg-filter-link%2$s" href="#" data-term-id="%1$s" >%3$s</a></li>', esc_attr( $filter['id'] ), ( $filter['id'] === $active_filter ) ? ' active' : '', esc_attr( $filter['name'] ) );
							}
							$filters_output .= sprintf( '%4$s<ul class="dp-dfg-level dp-dfg-taxonomy-level-%1$s dp-dfg-taxonomy-%3$s">%2$s</ul>', $levels_counter ++, $buttons_output, ( $filter_tax !== 'all' && isset( $filters_data[ $filter_tax ] ) ) ? $filters_data[ $filter_tax ]['name'] : $filter_tax, $label_output );
						}
						break;
					case 'select':
						$filter_layout_class = "dp-dfg-filters-dropdown-layout";
						foreach ( $filters_levels as $filter_tax => $filter_level ) {
							$buttons_output = '';
							$all_text       = $props['filter_dropdown_placeholder'];
							if ( is_array( $filters_data ) && isset( $filters_data[ $filter_tax ] ) ) {
								if ( '' !== $filters_data[ $filter_tax ]['label'] ) {
									$all_text = $filters_data[ $filter_tax ]['label'];
								} else {
									$all_text = 'Select the ' . get_taxonomy( $filters_data[ $filter_tax ]['name'] )->labels->name;
								}
							}
							foreach ( $filter_level as $filter ) {
								$buttons_output .= sprintf( '<li class="dp-dfg-filter"><a class="dp-dfg-filter-link%2$s" href="#" data-term-id="%1$s" >%3$s</a></li>', esc_attr( $filter['id'] ), ( $filter['id'] === $active_filter ) ? ' active' : '', esc_attr( $filter['name'] ) );
							}
							$filters_output .= sprintf( '<div class="dp-dfg-filters-dropdown closed"><p class="dp-dfg-dropdown-label" data-content="%4$s"><span class="dp-dfg-dropdown-placehoder">%4$s</span></p><ul class="dp-dfg-level dp-dfg-taxonomy-level-%1$s dp-dfg-taxonomy-%3$s">%2$s</ul></div>', $levels_counter ++, $buttons_output, ( $filter_tax !== 'all' && isset( $filters_data[ $filter_tax ] ) ) ? $filters_data[ $filter_tax ]['name'] : $filter_tax, $all_text );
						}
						if ( 'right' === $props['search_position'] ) {
							$filters_output = $filters_output . $search_output;
						} else if ( 'left' === $props['search_position'] ) {
							$filters_output = $search_output . $filters_output;
						}
						break;
				}
				$filters_output = apply_filters( 'dpdfg_custom_filters_output', $filters_output, $props, $filters );
				$filters_output = et_core_intentionally_unescaped( sprintf( '<div class="dp-dfg-filters %2$s">%1$s</div><!-- DPDFG End Filters Container -->', $filters_output, $filter_layout_class ), 'html' );
			}
			/*
			 * Search and filters
			 */
			if ( ( 'right' === $props['search_position'] || 'left' === $props['search_position'] ) && 'select' === $props['filter_layout'] ) {
				echo et_core_intentionally_unescaped( $filters_output, 'html' );
			} else if ( 'below' === $props['search_position'] ) {
				echo et_core_intentionally_unescaped( $filters_output . $search_output, 'html' );
			} else {
				echo et_core_intentionally_unescaped( $search_output . $filters_output, 'html' );
			}
			/*
			 * Posts
			 */
			$items_output = Dp_Dfg_Utils::get_items_html( $props, $posts_data['posts'] );
			echo et_core_intentionally_unescaped( sprintf( '<div class="dp-dfg-items">%1$s</div><!-- DPDFG End Posts Items Container -->', $items_output ), 'html' );
			/*
			 * Pagination
			 */
			if ( 'on' === $props['show_pagination'] && '-1' !== $posts_number ) {
				$base_url = esc_url_raw( wp_unslash( $_SERVER['REQUEST_URI'] ) );
				$base_url = explode( '?', $base_url, 2 );
				$url_args = isset( $base_url[1] ) ? '?' . $base_url[1] : '';
				$base_url = preg_replace( '/page\/\d\//', '', $base_url[0] );
				echo et_core_intentionally_unescaped( sprintf( '<div class="dp-dfg-pagination" data-base-url="%1$s" data-url-args="%2$s">', $base_url, $url_args ), 'html' );
				$base_url = $base_url . 'page/';
				if ( 'paged' === $props['pagination_type'] ) {
					$first_html = '';
					$last_html  = '';
					$pages_html = '';
					if ( intval( $props['offset_number'] ) ) {
						$max_pages = ceil( ( $posts_data['found_posts'] - intval( $props['offset_number'] ) ) / intval( $posts_number ) );
					} else {
						$max_pages = ceil( ( $posts_data['found_posts'] / $posts_number ) );
					}
					$hide_pagination = ( $posts_data['found_posts'] <= $posts_number ) ? ' dp-dfg-hide' : '';
					$previous_icon   = sprintf( '<a href="%4$s%1$s%5$s" data-page="%1$s" class="pagination-link"><span class="et-pb-icon">%3$s</span> %2$s</a>', $page - 1, esc_html( $props['previous_text'] ), esc_attr( et_pb_process_font_icon( $props['previous_icon'] ) ), $base_url, $url_args );
					$next_icon       = sprintf( '<a href="%4$s%1$s%5$s" data-page="%1$s" class="pagination-link"> %2$s <span class="et-pb-icon">%3$s</span></a>', $page + 1, esc_html( $props['next_text'] ), esc_attr( et_pb_process_font_icon( $props['next_icon'] ) ), $base_url, $url_args );
					if ( 'on' === $props['first_last'] ) {
						$first_icon = sprintf( '<a href="%4$s1%5$s" data-page="%1$s" class="pagination-link"><span class="et-pb-icon">%3$s</span> %2$s</a>', 1, esc_html( $props['first_text'] ), esc_attr( et_pb_process_font_icon( $props['first_icon'] ) ), $base_url, $url_args );
						$last_icon  = sprintf( '<a href="%4$s%1$s%5$s" data-page="%1$s" class="pagination-link"> %2$s <span class="et-pb-icon">%3$s</span></a>', $max_pages, esc_html( $props['last_text'] ), esc_attr( et_pb_process_font_icon( $props['last_icon'] ) ), $base_url, $url_args );
						$first_html = sprintf( '<li class="pagination-item dp-dfg-first-page dp-dfg-direction"  style="display: none;">%1$s</li>', $first_icon );
						$last_html  = sprintf( '<li class="pagination-item dp-dfg-last-page dp-dfg-direction">%1$s</li>', $last_icon );
					}
					$prev_html = sprintf( '<li class="pagination-item previous-posts dp-dfg-direction"  style="display: none;">%1$s</li>', $previous_icon );
					for ( $index = 0; $index < $max_pages; $index ++ ) {
						$pages_html .= sprintf( '<li class="pagination-item%2$s%3$s"><a href="%4$s%1$s%5$s" data-page="%1$s" class="pagination-link">%1$s</a></li>', $index + 1, ( $index + 1 ) === $page ? ' active' : '', ( $index >= $page + $props['pagination_pages'] || $index <= $page - $props['pagination_pages'] ) ? ' dp-dfg-hide' : '', $base_url, $url_args );
					}
					$next_html = sprintf( '<li class="pagination-item next-posts dp-dfg-direction">%1$s</li>', $next_icon );
					echo et_core_intentionally_unescaped( sprintf( '<ul class="pagination %1$s">%2$s</ul>', $hide_pagination, $first_html . $prev_html . $pages_html . $next_html . $last_html ), 'html' );
				} else {
					if ( $posts_data['found_posts'] > $props['offset_number'] + $posts_number ) {
						if ( 'button' === $props['pagination_type'] && '' !== $props['ajax_load_more_text'] ) {
							$button_output = $this->render_button(
								array(
									'button_classname'    => array(
										'et_pb_button',
										'dp-dfg-load-more-button',
									),
									'button_custom'       => $props['custom_load_more_button'],
									'button_rel'          => ( $props['load_more_button_rel'] ),
									'button_text'         => esc_html( $props['ajax_load_more_text'] ),
									'button_text_escaped' => true,
									'button_url'          => '#',
									'custom_icon'         => $props['load_more_button_icon'],
									'url_new_window'      => false,
									'display_button'      => ( '' !== $props['ajax_load_more_text'] ),
								)
							);
							echo et_core_intentionally_unescaped( $button_output, 'html' );
						} elseif ( 'scroll' === $props['pagination_type'] ) {
							echo( '<div  class="dp-dfg-ajax-scroll active"></div>' );
						}
					}
				}
				echo '</div><!-- DPDFG End Pagination Container -->';
			}
			/*
			 * Inline style to fix read more button icons
			 */
			echo '<style>.dp-dfg-more-button::before, .dp-dfg-more-button::after { content: attr(data-icon); }</style>';
			echo '</div><!-- DPDFG End Main Container -->';
		}

		/*
		 * End output
		 */

		return ob_get_clean();
	}

	public function responsive_css( $props, $layout, $render_slug ) {
		if ( $props['bg_items'] ) {
			ET_Builder_Element::set_style(
				$render_slug,
				array(
					'selector'    => '%%order_class%% .dp-dfg-item',
					'declaration' => sprintf( 'background-color: %1$s;', esc_html( $props['bg_items'] ) ),
				)
			);
		}
		if ( $props['bg_filters'] ) {
			ET_Builder_Element::set_style(
				$render_slug,
				array(
					'selector'    => '%%order_class%% .dp-dfg-skin-default .dp-dfg-filter a.dp-dfg-filter-link',
					'declaration' => sprintf( 'background-color: %1$s;', esc_html( $props['bg_filters'] ) ),
				)
			);
		}
		if ( $props['bg_filter_active'] ) {
			ET_Builder_Element::set_style(
				$render_slug,
				array(
					'selector'    => '%%order_class%% .dp-dfg-skin-default .dp-dfg-filter a.dp-dfg-filter-link.active, %%order_class%% .dp-dfg-skin-default .dp-dfg-dropdown-tag',
					'declaration' => sprintf( 'background-color: %1$s;', esc_html( $props['bg_filter_active'] ) ),
				)
			);
		}
		if ( $props['bg_pagination'] ) {
			ET_Builder_Element::set_style(
				$render_slug,
				array(
					'selector'    => '%%order_class%% .dp-dfg-skin-default .pagination-item a.pagination-link',
					'declaration' => sprintf( 'background-color: %1$s;', esc_html( $props['bg_pagination'] ) ),
				)
			);
		}
		if ( $props['bg_pagination_active'] ) {
			ET_Builder_Element::set_style(
				$render_slug,
				array(
					'selector'    => '%%order_class%% .dp-dfg-skin-default .pagination-item.active a.pagination-link',
					'declaration' => sprintf( 'background-color: %1$s;', esc_html( $props['bg_pagination_active'] ) ),
				)
			);
		}
		if ( $props['bg_search'] ) {
			ET_Builder_Element::set_style(
				$render_slug,
				array(
					'selector'    => '%%order_class%% .dp-dfg-search-input',
					'declaration' => sprintf( 'background-color: %1$s;', esc_html( $props['bg_search'] ) ),
				)
			);
		}
		if ( $props['bg_search_icon'] ) {
			ET_Builder_Element::set_style(
				$render_slug,
				array(
					'selector'    => '%%order_class%% .dp-dfg-search-icon',
					'declaration' => sprintf( 'background-color: %1$s;', esc_html( $props['bg_search_icon'] ) ),
				)
			);
		}
		if ( 'dp-dfg-layout-grid' === $layout ) {
			if ( '' !== $props['items_width_tablet'] || '' !== $props['items_width_phone'] || '' !== $props['items_width'] ) {
				$props['items_width_responsive_active'] = et_pb_get_responsive_status( $props['items_width_last_edited'] );
				$props['items_width_values']            = array(
					'desktop' => $props['items_width'],
					'tablet'  => $props['items_width_responsive_active'] ? $props['items_width_tablet'] : '',
					'phone'   => $props['items_width_responsive_active'] ? $props['items_width_phone'] : '',
				);
				$modify_css_values                      = array();
				foreach ( $props['items_width_values'] as $key => $width ) {
					if ( '' === $width ) {
						$modify_css_values[ $key ] = '';
					} else {
						$modify_css_values[ $key ] = ' repeat(auto-fill, minmax(' . esc_attr( $width ) . ', 1fr))';
					}
				}
				foreach ( $modify_css_values as $device => $current_value ) {
					if ( '' === $current_value ) {
						continue;
					}
					$declaration = sprintf( '%1$s: %2$s%3$s', 'grid-template-columns', $current_value, ';' );
					$style       = array(
						'selector'    => '%%order_class%% .dp-dfg-container.dp-dfg-layout-grid .dp-dfg-items',
						'declaration' => $declaration,
					);
					if ( 'desktop_only' === $device ) {
						$style['media_query'] = ET_Builder_Element::get_media_query( 'min_width_981' );
					} elseif ( 'desktop' !== $device ) {
						$current_media_query  = 'tablet' === $device ? 'max_width_980' : 'max_width_767';
						$style['media_query'] = ET_Builder_Element::get_media_query( $current_media_query );
					}
					ET_Builder_Element::set_style( $render_slug, $style );
				}
			}
			if ( '' !== $props['column_gutter_tablet'] || '' !== $props['column_gutter_phone'] || '' !== $props['column_gutter'] ) {
				$props['column_gutter_responsive_active'] = et_pb_get_responsive_status( $props['column_gutter_last_edited'] );
				$props['column_gutter_values']            = array(
					'desktop' => $props['column_gutter'],
					'tablet'  => $props['column_gutter_responsive_active'] ? $props['column_gutter_tablet'] : '',
					'phone'   => $props['column_gutter_responsive_active'] ? $props['column_gutter_phone'] : '',
				);
				$this->generate_responsive_css( $props['column_gutter_values'], '%%order_class%% .dp-dfg-layout-grid .dp-dfg-items', 'column-gap', $render_slug );
			}
			if ( '' !== $props['row_gutter_tablet'] || '' !== $props['row_gutter_phone'] || '' !== $props['row_gutter'] ) {
				$props['row_gutter_responsive_active'] = et_pb_get_responsive_status( $props['row_gutter_last_edited'] );
				$props['row_gutter_values']            = array(
					'desktop' => $props['row_gutter'],
					'tablet'  => $props['row_gutter_responsive_active'] ? $props['row_gutter_tablet'] : '',
					'phone'   => $props['row_gutter_responsive_active'] ? $props['row_gutter_phone'] : '',
				);
				$this->generate_responsive_css( $props['row_gutter_values'], '%%order_class%% .dp-dfg-layout-grid .dp-dfg-items', 'row-gap', $render_slug );
			}
		}
		if ( 'dp-dfg-layout-masonry' === $layout ) {
			if ( '' !== $props['items_width_tablet'] || '' !== $props['items_width_phone'] || '' !== $props['items_width'] ) {
				$props['items_width_responsive_active'] = et_pb_get_responsive_status( $props['items_width_last_edited'] );
				$props['items_width_values']            = array(
					'desktop' => $props['items_width'],
					'tablet'  => $props['items_width_responsive_active'] ? $props['items_width_tablet'] : '',
					'phone'   => $props['items_width_responsive_active'] ? $props['items_width_phone'] : '',
				);
				$modify_css_values                      = array();
				foreach ( $props['items_width_values'] as $key => $width ) {
					if ( '' === $width ) {
						$modify_css_values[ $key ] = '';
					} else {
						$modify_css_values[ $key ] = ' repeat(auto-fill, minmax(' . $width . ', 1fr))';
					}
				}
				foreach ( $modify_css_values as $device => $current_value ) {
					if ( '' === $current_value ) {
						continue;
					}
					$declaration = '';
					$declaration = sprintf( '%1$s: %2$s%3$s', 'grid-template-columns', $current_value, ';' );
					if ( '' === $declaration ) {
						continue;
					}
					$style = array(
						'selector'    => '%%order_class%% .dp-dfg-container.dp-dfg-layout-masonry .dp-dfg-items',
						'declaration' => $declaration,
					);
					if ( 'desktop_only' === $device ) {
						$style['media_query'] = ET_Builder_Element::get_media_query( 'min_width_981' );
					} elseif ( 'desktop' !== $device ) {
						$current_media_query  = 'tablet' === $device ? 'max_width_980' : 'max_width_767';
						$style['media_query'] = ET_Builder_Element::get_media_query( $current_media_query );
					}
					ET_Builder_Element::set_style( $render_slug, $style );
				}
			}
			if ( '' !== $props['column_gutter_tablet'] || '' !== $props['column_gutter_phone'] || '' !== $props['column_gutter'] ) {
				$props['column_gutter_responsive_active'] = et_pb_get_responsive_status( $props['column_gutter_last_edited'] );
				$props['column_gutter_values']            = array(
					'desktop' => $props['column_gutter'],
					'tablet'  => $props['column_gutter_responsive_active'] ? $props['column_gutter_tablet'] : '',
					'phone'   => $props['column_gutter_responsive_active'] ? $props['column_gutter_phone'] : '',
				);
				$this->generate_responsive_css( $props['column_gutter_values'], '%%order_class%% .dp-dfg-layout-masonry .dp-dfg-items', 'column-gap', $render_slug );
			}
			if ( '' !== $props['row_gutter_tablet'] || '' !== $props['row_gutter_phone'] || '' !== $props['row_gutter'] ) {
				$props['row_gutter_responsive_active'] = et_pb_get_responsive_status( $props['row_gutter_last_edited'] );
				$props['row_gutter_values']            = array(
					'desktop' => $props['row_gutter'],
					'tablet'  => $props['row_gutter_responsive_active'] ? $props['row_gutter_tablet'] : '',
					'phone'   => $props['row_gutter_responsive_active'] ? $props['row_gutter_phone'] : '',
				);
				$this->generate_responsive_css( $props['row_gutter_values'], '%%order_class%% .dp-dfg-layout-masonry .dp-dfg-items', 'row-gap', $render_slug );
			}
		}
		if ( 'dp-dfg-layout-list' === $layout ) {
			if ( '' !== $props['column_gutter_tablet'] || '' !== $props['column_gutter_phone'] || '' !== $props['column_gutter'] ) {
				$props['column_gutter_responsive_active'] = et_pb_get_responsive_status( $props['column_gutter_last_edited'] );
				$props['column_gutter_values']            = array(
					'desktop' => $props['column_gutter'],
					'tablet'  => $props['column_gutter_responsive_active'] ? $props['column_gutter_tablet'] : '',
					'phone'   => $props['column_gutter_responsive_active'] ? $props['column_gutter_phone'] : '',
				);
				$this->generate_responsive_css( $props['column_gutter_values'], '%%order_class%% .dp-dfg-layout-list .dp-dfg-item', 'column-gap', $render_slug );
			}
			if ( '' !== $props['row_gutter_tablet'] || '' !== $props['row_gutter_phone'] || '' !== $props['row_gutter'] ) {
				$props['row_gutter_responsive_active'] = et_pb_get_responsive_status( $props['row_gutter_last_edited'] );
				$props['row_gutter_values']            = array(
					'desktop' => $props['row_gutter'],
					'tablet'  => $props['row_gutter_responsive_active'] ? $props['row_gutter_tablet'] : '',
					'phone'   => $props['row_gutter_responsive_active'] ? $props['row_gutter_phone'] : '',
				);
				$this->generate_responsive_css( $props['row_gutter_values'], '%%order_class%% .dp-dfg-layout-list .dp-dfg-item', 'grid-row-gap', $render_slug );
			}
			if ( ( '' !== $props['thumb_min_width_tablet'] || '' !== $props['thumb_min_width_phone'] || '' !== $props['thumb_min_width'] ) && ( '' !== $props['thumb_width_tablet'] || '' !== $props['thumb_width_phone'] || '' !== $props['thumb_width'] ) ) {
				$props['thumb_min_width_responsive_active'] = et_pb_get_responsive_status( $props['thumb_min_width_last_edited'] );
				$props['thumb_min_width_values']            = array(
					'desktop' => $props['thumb_min_width'],
					'tablet'  => $props['thumb_min_width_responsive_active'] ? $props['thumb_min_width_tablet'] : '',
					'phone'   => $props['thumb_min_width_responsive_active'] ? $props['thumb_min_width_phone'] : '',
				);
				$props['thumb_width_responsive_active']     = et_pb_get_responsive_status( $props['thumb_width_last_edited'] );
				$props['thumb_width_values']                = array(
					'desktop' => $props['thumb_width'],
					'tablet'  => $props['thumb_width_responsive_active'] ? $props['thumb_width_tablet'] : '',
					'phone'   => $props['thumb_width_responsive_active'] ? $props['thumb_width_phone'] : '',
				);
				$modify_css_values                          = array();
				foreach ( $props['thumb_min_width_values'] as $key => $width ) {
					if ( '' === $width ) {
						$modify_css_values[ $key ] = ' 1fr';
					} else {
						$modify_css_values[ $key ] = ' minmax(' . esc_attr( $width ) . ' , ' . $props['thumb_width_values'][ $key ] . ') 1fr';
					}
				}
				foreach ( $modify_css_values as $device => $current_value ) {
					if ( '' === $current_value ) {
						continue;
					}
					$declaration = sprintf( '%1$s: %2$s%3$s %4$s: %2$s%3$s', 'grid-template-columns', $current_value, ';', '-ms-grid-columns' );
					$style       = array(
						'selector'    => '%%order_class%% .dp-dfg-layout-list .dp-dfg-item',
						'declaration' => $declaration,
					);
					if ( 'desktop_only' === $device ) {
						$style['media_query'] = ET_Builder_Element::get_media_query( 'min_width_981' );
					} elseif ( 'desktop' !== $device ) {
						$current_media_query  = 'tablet' === $device ? 'max_width_980' : 'max_width_767';
						$style['media_query'] = ET_Builder_Element::get_media_query( $current_media_query );
					}
					ET_Builder_Element::set_style( $render_slug, $style );
				}
			}
		}
		if ( 'dp-dfg-layout-list' === $layout || 'dp-dfg-layout-grid' === $layout || $layout === 'dp-dfg-layout-masonry' ) {
			if ( '' !== $props['column_gutter_tablet'] || '' !== $props['column_gutter_phone'] || '' !== $props['column_gutter'] ) {
				$props['column_gutter_responsive_active'] = et_pb_get_responsive_status( $props['column_gutter_last_edited'] );
				$props['column_gutter_values']            = array(
					'desktop' => $props['column_gutter'],
					'tablet'  => $props['column_gutter_responsive_active'] ? $props['column_gutter_tablet'] : '',
					'phone'   => $props['column_gutter_responsive_active'] ? $props['column_gutter_phone'] : '',
				);
				$this->generate_responsive_css( $props['column_gutter_values'], '%%order_class%% .dp-dfg-container', 'column-gap', $render_slug );
			}
			if ( '' !== $props['row_gutter_tablet'] || '' !== $props['row_gutter_phone'] || '' !== $props['row_gutter'] ) {
				$props['row_gutter_responsive_active'] = et_pb_get_responsive_status( $props['row_gutter_last_edited'] );
				$props['row_gutter_values']            = array(
					'desktop' => $props['row_gutter'],
					'tablet'  => $props['row_gutter_responsive_active'] ? $props['row_gutter_tablet'] : '',
					'phone'   => $props['row_gutter_responsive_active'] ? $props['row_gutter_phone'] : '',
				);
				$this->generate_responsive_css( $props['row_gutter_values'], '%%order_class%% .dp-dfg-container', 'row-gap', $render_slug );
			}
		}
		if ( '' !== $props['grid_font_size_tablet'] || '' !== $props['grid_font_size_phone'] || '' !== $props['grid_font_size'] ) {
			$props['grid_font_size_responsive_active'] = et_pb_get_responsive_status( $props['grid_font_size_last_edited'] );
			$props['grid_font_size_values']            = array(
				'desktop' => $props['grid_font_size'],
				'tablet'  => $props['grid_font_size_responsive_active'] ? $props['grid_font_size_tablet'] : '',
				'phone'   => $props['grid_font_size_responsive_active'] ? $props['grid_font_size_phone'] : '',
			);
			$this->generate_responsive_css( $props['grid_font_size_values'], '%%order_class%% .dp-dfg-container', 'font-size', $render_slug );
		}
		if ( '' !== $props['overlay_icon_color'] ) {
			ET_Builder_Element::set_style(
				$render_slug,
				array(
					'selector'    => '%%order_class%% .dp-dfg-overlay span.et_overlay:before',
					'declaration' => sprintf(
						'color: %1$s !important;',
						esc_html( $props['overlay_icon_color'] )
					),
				)
			);
		}
		if ( '' !== $props['hover_overlay_color'] ) {
			ET_Builder_Element::set_style(
				$render_slug,
				array(
					'selector'    => '%%order_class%% .dp-dfg-overlay span.et_overlay',
					'declaration' => sprintf(
						'background-color: %1$s;',
						esc_html( $props['hover_overlay_color'] )
					),
				)
			);
		}
		if ( 'select' === $props['filter_layout'] ) {
			if ( '' !== $props['filters_width_tablet'] || '' !== $props['filters_width_phone'] || '' !== $props['filters_width'] ) {
				$props['filters_width_responsive_active'] = et_pb_get_responsive_status( $props['filters_width_last_edited'] );
				$props['filters_width_values']            = array(
					'desktop' => $props['filters_width'],
					'tablet'  => $props['filters_width_responsive_active'] ? $props['filters_width_tablet'] : '',
					'phone'   => $props['filters_width_responsive_active'] ? $props['filters_width_phone'] : '',
				);
				$modify_css_values                        = array();
				foreach ( $props['filters_width_values'] as $key => $width ) {
					if ( '' === $width ) {
						$modify_css_values[ $key ] = '';
					} else {
						$modify_css_values[ $key ] = ' repeat(' . esc_attr( $width ) . ', 1fr)';
					}
				}
				foreach ( $modify_css_values as $device => $current_value ) {
					if ( '' === $current_value ) {
						continue;
					}
					$declaration = sprintf( '%1$s: %2$s%3$s', 'grid-template-columns', $current_value, ';' );
					$style       = array(
						'selector'    => '%%order_class%% .dp-dfg-container .dp-dfg-filters-dropdown-layout',
						'declaration' => $declaration,
					);
					if ( 'desktop_only' === $device ) {
						$style['media_query'] = ET_Builder_Element::get_media_query( 'min_width_981' );
					} elseif ( 'desktop' !== $device ) {
						$current_media_query  = 'tablet' === $device ? 'max_width_980' : 'max_width_767';
						$style['media_query'] = ET_Builder_Element::get_media_query( $current_media_query );
					}
					ET_Builder_Element::set_style( $render_slug, $style );
				}
			}
		}
	}

	public function generate_responsive_css( $values_array, $css_selector, $css_property, $function_name ) {
		if ( function_exists( 'et_pb_responsive_options' ) ) {
			et_pb_responsive_options()->generate_responsive_css( $values_array, $css_selector, $css_property, $function_name );
		} else {
			et_pb_generate_responsive_css( $values_array, $css_selector, $css_property, $function_name );
		}
	}

	public function get_data_module_for_ajax( $props ) {
		$data_module_important_keys = array(
			/* Query */
			'custom_query',
			'include_categories',
			'multiple_cpt',
			'use_taxonomy_terms',
			'multiple_taxonomies',
			'include_terms',
			'terms_relation',
			'include_children_terms',
			'exclude_taxonomies',
			'exclude_terms',
			'taxonomies_relation',
			'exclude_taxonomies_relation',
			'post_number',
			'offset_number',
			'order',
			'orderby',
			'meta_key',
			'meta_type',
			'show_private',
			'sticky_posts',
			'remove_current_post',
			'no_results',
			/* Posts elements options */
			'show_thumbnail',
			'thumbnail_action',
			'thumbnail_size',
			'gallery_cf_name',
			'use_overlay',
			'overlay_icon_color',
			'hover_overlay_color',
			'hover_icon',
			'show_title',
			'title_link',
			'show_post_meta',
			'show_author',
			'author_prefix_text',
			'show_date',
			'date_format',
			'show_terms',
			'show_terms_taxonomy',
			'show_comments',
			'show_content',
			'truncate_content',
			'read_more',
			'read_more_text',
			'read_more_window',
			'read_more_button_icon',
			'show_custom_content',
			'custom_content_container',
			'show_custom_fields',
			'custom_fields',
			'custom_url',
			'custom_url_field_name',
			/* Filters options fields */
			'show_filters',
			'use_custom_terms_filters',
			'filter_layout',
			'multifilter',
			'multifilter_relation',
			'multilevel',
			'multilevel_relation',
			'multilevel_tax_data',
			'filter_taxonomies',
			'filter_terms',
			'default_filter',
			'hide_all',
			'all_text',
			'filters_sort',
			'filters_custom',
			'filters_order',
			/* Search fields */
			'show_search',
			/* Pagination fields */
			'show_pagination',
			'pagination_type',
			'ajax_load_more_text',
			'next_icon',
			'next_text',
			'previous_icon',
			'previous_text',
			'pagination_pages',
			/* Layout options fields */
			'items_layout',
			'items_skin',
			'items_width',
			'thumb_width',
			/* Cache */
			'cache_on_page',
			/* Background Fields */
			'bg_items',
			/* Font Fields */
			'dpdfg_entry_title_level',
			/* Extra */
			'the_ID',
			'conditional_tags',
			'query_var',
			'admin_label',
			'module_id',
			'module_class',
		);
		$data                       = array_intersect_key( $props, array_flip( $data_module_important_keys ) );

		return $data;
	}

}

new DpDiviFilterGrid();
